## NitTalk -
NitTalk is a fully functional Group Chat Messaging App with multiple features built with Kotlin.

## Techs Used 💻
- [Kotlin](https://kotlinlang.org/) - First class and official programming language for Android development.
- [Coroutines](https://kotlinlang.org/docs/coroutines-overview.html) - For Asynchronous.
- [Flow](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines.flow/-flow/) - A cold asynchronous data stream that sequentially emits values and completes normally or with an exception.
- [StateFlow](https://developer.android.com/kotlin/flow/stateflow-and-sharedflow) - StateFlow is a state-holder observable flow that emits the current and new state updates to its collectors.
- [Android Architecture Components](https://developer.android.com/topic/architecture) - Collection of libraries that help you design robust, testable, and maintainable apps.
  - [ViewModel](https://developer.android.com/topic/libraries/architecture/viewmodel) - Stores UI-related data that isn't destroyed on UI changes.
  - [ViewBinding](https://developer.android.com/topic/libraries/view-binding) - Generates a binding class for each XML layout file present in that module and allows you to more easily write code that interacts with views.
  - [Room Database](https://developer.android.com/training/data-storage/room) - Room is an android library which is an ORM which wraps android's native SQLite database.
  - [Datastore](https://developer.android.com/topic/libraries/architecture/datastore) - Jetpack DataStore is a data storage solution that allows you to store key-value pairs or typed objects with protocol buffers.
- [Firebase](https://firebase.google.com/) - To support Email based Authentication and save data online.
- [Dagger-Hilt](https://dagger.dev/hilt/) - Standard library to incorporate Dagger dependency injection into an Android application.
- [Jitsi Meet SDK](https://jitsi.github.io/handbook/docs/dev-guide/dev-guide-android-sdk) - It is an Android library which embodies the whole Jitsi Meet experience and makes it reusable by third-party apps.
- [Glide](https://github.com/bumptech/glide) - An image loading and caching library for Android focused on smooth scrolling

## Firebase FlowChart 👀
 [**Firebase Flow Chart**](https://whimsical.com/nit-talk-firebase-flowchart-AqJqtDqdypWyPiYBVTG5cS)

## Screenshots 📷
| Login | SignUp | Info | HomeScreen |
| ----- | ------ | ---- | ---------- |
| <img src="https://user-images.githubusercontent.com/65807152/134795936-bc73de63-6e28-484a-842c-241c5f3cbd90.jpg" width=250> | <img src="https://user-images.githubusercontent.com/65807152/134796093-5c75938e-87d8-485e-ae06-72636d45a786.jpg" width=250> | <img src="https://user-images.githubusercontent.com/65807152/134796125-b9f73c54-02e7-49d1-8c46-18d5d32786ff.jpg" width=250> | <img src="https://user-images.githubusercontent.com/65807152/134796140-be176ba0-1940-4ec4-ab1f-ad96ec8e9055.jpg" width=250> |

| Message Screen | Message Notification | User Status | Friend Screen(Dummy Data) |
| -------------- | -------------------- | ----------- | ------------- |
| <img src="https://user-images.githubusercontent.com/65807152/134796162-ee29c21f-739f-4847-97c7-e655fa41728c.jpg" width=250> | <img src="https://user-images.githubusercontent.com/65807152/125169992-5cb5e500-e1ca-11eb-836b-ac2d82a4c23d.jpg" width=250> | <img src="https://user-images.githubusercontent.com/65807152/134796181-885b9b93-f911-49a3-be9e-45fb5e1f2c4f.jpg" width=250> | <img src="https://user-images.githubusercontent.com/65807152/134796193-06f31923-ac0c-4309-8fd0-f3dade517c51.jpg" width=250> |

| Search User | Friend Chat | Friend Message | Profile |
| ----------- | ----------- | -------------- | ------- |
| <img src="https://user-images.githubusercontent.com/65807152/134796301-bc081259-16d3-49e3-813b-fdecbc0dc564.jpg" width=250> | <img src="https://user-images.githubusercontent.com/65807152/134796318-01691a13-698e-4af8-842b-66a3f4b5eb5b.jpg" width=250> | <img src="https://user-images.githubusercontent.com/65807152/134796333-16097913-c528-4b06-bd79-ba0c909f7227.jpg" width=250> | <img src="https://user-images.githubusercontent.com/65807152/134796360-60c12baf-f31d-4ff8-b6dd-d2948f786426.jpg" width=250> |

| Update Profile |
| -------------- |
| <img src="https://user-images.githubusercontent.com/65807152/134796389-720f453e-5d25-44b5-9571-5de078f3a46f.jpg" width=250> |







